//  $Id: TclList.cc 1.6 Thu, 23 Apr 1998 19:52:07 -0700 wlee $
//
//  Copyright (c) 1994 by the University of Southern California
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and its
//  documentation in source and binary forms for lawful non-commercial
//  purposes and without fee is hereby granted, provided that the above
//  copyright notice appear in all copies and that both the copyright
//  notice and this permission notice appear in supporting documentation,
//  and that any documentation, advertising materials, and other materials
//  related to such distribution and use acknowledge that the software was
//  developed by the University of Southern California, Information
//  Sciences Institute. The name of the USC may not be used to endorse or
//  promote products derived from this software without specific prior
//  written permission.
//
//  THE UNIVERSITY OF SOUTHERN CALIFORNIA DOES NOT MAKE ANY
//  REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//  PURPOSE.  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
//  TITLE, AND NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT, TORT,
//  OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE
//  OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to 
//  ratoolset@isi.edu.
//
//  Author(s): WeeSan Lee <wlee@ISI.EDU>


#if !defined(IDENT_OFF)
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7) 
static char ident[] = 
   "@(#)$Id: TclList.cc 1.6 Thu, 23 Apr 1998 19:52:07 -0700 wlee $";
#endif
#endif


#include "config.h"
#include <cstdlib>
#include "TclList.hh"
#include "TclApp.hh"


int TclList::insert(char *pzcItem)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   return pcApp->evalf("%s insert end %s", getName(), pzcItem);
}

int TclList::remove(int iIndex)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   return pcApp->evalf("%s delete %d", getName(), iIndex);
}

int TclList::clear(void)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   return pcApp->evalf("%s delete 0 end", getName());   
}

int TclList::select(int iBegin, int iEnd)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   return pcApp->evalf("%s selection set %d %d", getName(), iBegin, iEnd);
}

int TclList::size(void)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   if (!pcApp->evalf("%s index end", getName())) return 0;
   return atoi(pcApp->getResult());
}

int TclList::getActiveItem(void)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   if (!pcApp->evalf("%s index active", getName())) return -1;
   const char *p = pcApp->getResult();
   if (*p)
      return atoi(pcApp->getResult());
   else
      return -1;
}

int TclList::getCurrentItem(void)
{
   TclApplication *pcApp = (TclApplication *)getExtraArgument();
   if (!pcApp->evalf("%s curselection", getName())) return -1;
   const char *p = pcApp->getResult();
   if (*p)
      return atoi(pcApp->getResult());
   else
      return -1;
}
