// $Id: SetOfUInt.hh 1.1.1.4 Thu, 11 Mar 1999 12:20:06 -0800 cengiz $
// 
//  Copyright (c) 1994 by the University of Southern California
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and its
//  documentation in source and binary forms for lawful non-commercial
//  purposes and without fee is hereby granted, provided that the above
//  copyright notice appear in all copies and that both the copyright
//  notice and this permission notice appear in supporting documentation,
//  and that any documentation, advertising materials, and other materials
//  related to such distribution and use acknowledge that the software was
//  developed by the University of Southern California, Information
//  Sciences Institute. The name of the USC may not be used to endorse or
//  promote products derived from this software without specific prior
//  written permission.
//
//  THE UNIVERSITY OF SOUTHERN CALIFORNIA DOES NOT MAKE ANY
//  REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//  PURPOSE.  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
//  TITLE, AND NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT, TORT,
//  OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE
//  OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to
//  ratoolset@isi.edu.
//
//  Author(s): Cengiz Alaettinoglu <cengiz@ISI.EDU>

#ifndef SetOfUInt_H
#define SetOfUInt_H


#include "config.h"
#include "unsigned.OXPSet.h"

#define BASEOF_SetOfUInt unsignedOXPSet

class SetOfUInt : public BASEOF_SetOfUInt {
public:
   bool isEmpty() const {
      return ((SetOfUInt *) this)->BASEOF_SetOfUInt::empty();
   }
   Pix first() const {
      return ((SetOfUInt *) this)->BASEOF_SetOfUInt::first();
   }
   void next(Pix& i) const {
      ((SetOfUInt *) this)->BASEOF_SetOfUInt::next(i);
   }
   const unsigned& operator () (Pix i) const {
      return ((SetOfUInt *) this)->BASEOF_SetOfUInt::operator()(i);
   }
   int contains(unsigned  item) const {     // is item in set?
      return ((SetOfUInt *) this)->BASEOF_SetOfUInt::contains(item);
   }
};

#endif   // SetOfUInt_H
